'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 31 July 2001 at 3:17:50 pm'!
Model subclass: #TestInterfaceBase
	instanceVariableNames: 'result duration classPattern selectorPattern suite '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Interface'!

!TestInterfaceBase commentStamp: 'fg 7/30/2001 15:19' prior: 0!
ABSTRACT base class for user interfaces to the SUnit framework.

Instance Variables:
	result			<TestResult>
	suite 			<TestSuite>
	classPattern		<String>
	selectorPattern	<String>
	duration		<Integer> [ms]!
]style[(47 1 1 3 44 10 13 9 18 6 20 6 14 7 6)f1,f1cgreen;b,f1cred;b,f1bcblack;,f1,f1LTestResult Hierarchy;,f1,f1LTestSuite Hierarchy;,f1,f1LString Hierarchy;,f1,f1LString Hierarchy;,f1,f1LInteger Hierarchy;,f1!


!TestInterfaceBase methodsFor: 'accessing' stamp: 'fg 7/30/2001 15:22'!
buildSuite
	suite := TestSuite new.
	self matchingClasses do: [:class |
		| matchingSelectors |
		matchingSelectors := class selectors select: [:selector |
			self selectorPattern match: selector].
		matchingSelectors do: [:selector |
			suite addTest: (class selector: selector)]].
! !

!TestInterfaceBase methodsFor: 'accessing' stamp: 'fg 7/30/2001 15:21'!
suite
	suite isNil ifTrue: [self buildSuite].
	^ suite! !

!TestInterfaceBase methodsFor: 'accessing' stamp: 'fg 7/30/2001 15:20'!
suite: aTestSuite
	suite := aTestSuite! !

!TestInterfaceBase methodsFor: 'test processing' stamp: 'fg 7/30/2001 15:45'!
run
	self subclassResponsibility ! !


!TestInterfaceBase class methodsFor: 'processing' stamp: 'fg 7/30/2001 15:43'!
runSuite: aTestSuite
	^ (self new suite: aTestSuite) run
! !


!TestModel methodsFor: 'test processing' stamp: 'fg 7/30/2001 15:47'!
run
	self openAsMorph! !


!TestRunner methodsFor: 'test processing' stamp: 'fg 7/30/2001 15:52'!
run
	self runTests.
	^ result! !


!TestSuite methodsFor: 'adding' stamp: 'fg 7/30/2001 15:01'!
addTests: aCollection
	aCollection do: [:eachTest | self addTest: eachTest]
! !

Model subclass: #TestInterfaceBase
	instanceVariableNames: 'result duration suite classPattern selectorPattern '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Interface'!
