'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 1 August 2001 at 1:47:19 am'!
Object subclass: #SmlNormalizer
	instanceVariableNames: 'input result plainString strings propertyRun '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Compression'!
Object subclass: #SmlProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Property'!
SmlProperty subclass: #SmlBasicProperty
	instanceVariableNames: 'bold emphasis italic typewritter underlineLevel '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Property'!

!SmlBasicProperty commentStamp: '<historical>' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

SmlProperty subclass: #SmlDecoratedProperty
	instanceVariableNames: 'property '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Property'!
SmlDecoratedProperty subclass: #SmlColorProperty
	instanceVariableNames: 'fontColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Property'!
OrderedCollection subclass: #SmlPropertyRun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Compression'!

!SmlPropertyRun commentStamp: '<historical>' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

Object subclass: #SmlScanner
	instanceVariableNames: 'tokenType token hereChar aheadChar source buffer '
	classVariableNames: 'TypeTable '
	poolDictionaries: ''
	category: 'Sml-Parsing'!
SmlScanner subclass: #SmlParser
	instanceVariableNames: 'here hereType tagStack resultStack result '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Parsing'!
SmlDecoratedProperty subclass: #SmlSizeProperty
	instanceVariableNames: 'pointSize '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Property'!
Object subclass: #SmlText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Text'!

!SmlText commentStamp: '<historical>' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

SmlText subclass: #SmlCompositeText
	instanceVariableNames: 'textCollection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Text'!
SmlText subclass: #SmlDecoratedText
	instanceVariableNames: 'property string '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Text'!
SmlText subclass: #SmlPlainText
	instanceVariableNames: 'words blanks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Text'!

!SmlPlainText commentStamp: '<historical>' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

SmlText subclass: #SmlTaggedText
	instanceVariableNames: 'tag text '
	classVariableNames: 'TagMeanings '
	poolDictionaries: ''
	category: 'Sml-Text'!

!SmlTaggedText commentStamp: '<historical>' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

SmlText subclass: #SmlTextRun
	instanceVariableNames: 'plainString strings propertyRun '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Compression'!

!ReadStream methodsFor: 'accessing' stamp: 'fg 7/28/2001 02:19'!
readStream
	^ self! !


!SequenceableCollection methodsFor: 'converting' stamp: 'fg 7/28/2001 02:22'!
readStream 
	^ ReadStream on: self! !

!SequenceableCollection methodsFor: 'converting' stamp: 'fg 7/30/2001 00:45'!
writeStream 
	^ WriteStream on: self! !


!SmlNormalizer methodsFor: 'accessing' stamp: 'fg 7/30/2001 05:02'!
input
	^ input! !

!SmlNormalizer methodsFor: 'accessing' stamp: 'fg 7/30/2001 06:42'!
input: aSmlDecoratedText
	input _ aSmlDecoratedText! !

!SmlNormalizer methodsFor: 'accessing' stamp: 'fg 7/30/2001 06:02'!
inputStream: aStream
	self input: (SmlParser on: aStream) text decorated! !

!SmlNormalizer methodsFor: 'normalization' stamp: 'fg 7/30/2001 08:44'!
addString: aString withProperty: aProperty
	(strings isEmpty and: [aProperty isPlain])
		ifTrue: 
			[plainString _ plainString , aString. 
			^ self].

	propertyRun isEmpty 
		ifTrue:
			[propertyRun add: aProperty.
			strings add: aString.
			^ self].

	propertyRun last = aProperty 
		ifTrue: [^ strings add: (strings removeLast withoutTrailingBlanks , aString)].
	
	propertyRun add: aProperty.
	strings add: aString.! !

!SmlNormalizer methodsFor: 'normalization' stamp: 'fg 7/30/2001 08:38'!
normalize
	plainString _ String new.
	strings _ OrderedCollection new.
	propertyRun _ SmlPropertyRun new.
	input decoratedTextDo: 
		[:text | self addString: text string withProperty: text property].! !

!SmlNormalizer methodsFor: 'normalization' stamp: 'fg 7/30/2001 08:44'!
normalize: aStringOrStream
	^ self 
		inputStream: aStringOrStream;
		normalize
! !

!SmlNormalizer methodsFor: 'normalization' stamp: 'fg 7/30/2001 06:41'!
withoutComposites
	result _ OrderedCollection new.
	input decoratedTextDo: 
		[:text | 
		result add: text].
	^ result! !


!SmlProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:06'!
= aSmlProperty
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:06'!
hash
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:19'!
bold
	self subclassResponsibility! !

!SmlProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:20'!
emphasis
	self subclassResponsibility! !

!SmlProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:42'!
italic
	self subclassResponsibility! !

!SmlProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:21'!
plain
	self subclassResponsibility! !

!SmlProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:21'!
strongEmphasis
	self subclassResponsibility! !

!SmlProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:21'!
typewritter
	self subclassResponsibility! !

!SmlProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:21'!
underline
	self subclassResponsibility! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 00:55'!
pointSize: anInteger
	^ (SmlSizeProperty on: self) pointSize: anInteger! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:02'!
size0
	^ self pointSize: 0! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:02'!
size1
	^ self pointSize: 1! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:02'!
size2
	^ self pointSize: 2! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:02'!
size3
	^ self pointSize: 3! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:02'!
size4
	^ self pointSize: 4! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:03'!
size5
	^ self pointSize: 5! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:03'!
size6
	^ self pointSize: 6! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:02'!
size7
	^ self pointSize: 7! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:03'!
size8
	^ self pointSize: 8! !

!SmlProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 01:03'!
size9
	^ self pointSize: 9! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:05'!
black
	^ self fontColor: #black! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:05'!
blue
	^ self fontColor: #blue! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:06'!
cyan
	^ self fontColor: #cyan! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:05'!
fontColor: aSymbol
	^ (SmlColorProperty on: self) fontColor: aSymbol! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:06'!
green
	^ self fontColor: #green! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:06'!
magenta
	^ self fontColor: #magenta! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:06'!
red
	^ self fontColor: #red! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:06'!
white
	^ self fontColor: #white! !

!SmlProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 01:06'!
yellow
	^ self fontColor: #yellow! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 04:16'!
affectsBlanks
	^ self isColored or: [self isSized or: [self isUnderlined]]! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:06'!
isBold
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 03:56'!
isColored
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:13'!
isEmphasized
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:07'!
isItalic
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:07'!
isPlain
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 03:56'!
isSized
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:15'!
isStrongEmphasized
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:07'!
isTypewritter
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 03:56'!
isUnderlined
	self subclassResponsibility ! !

!SmlProperty methodsFor: 'printing' stamp: 'fg 7/30/2001 01:18'!
printOn: aStream
	aStream nextPut: $<.
	self printPropertyOn: aStream.
	aStream
		skip: -1; 
		nextPut: $>.! !

!SmlProperty methodsFor: 'printing' stamp: 'fg 7/29/2001 12:47'!
printPropertyOn: aStream
	self subclassResponsibility 
! !


!SmlBasicProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:17'!
= aProperty
	^ self class == aProperty class 
	and: [self isBold 				= aProperty isBold
	and: [self emphasisSymbol		= aProperty emphasisSymbol
	and: [self isItalic 				= aProperty isItalic
	and: [self isTypewritter 			= aProperty isTypewritter
	and: [self underlineLevel		= aProperty underlineLevel]]]]]! !

!SmlBasicProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:14'!
hash 
	^ bold bitXor: (emphasis bitXor: (italic bitXor: (typewritter bitXor: underlineLevel)))! !

!SmlBasicProperty methodsFor: 'initialization' stamp: 'fg 7/29/2001 00:34'!
initialize
	self plain! !

!SmlBasicProperty methodsFor: 'accessing' stamp: 'fg 7/30/2001 07:15'!
emphasisSymbol
	^ emphasis! !

!SmlBasicProperty methodsFor: 'accessing' stamp: 'fg 7/30/2001 07:15'!
underlineLevel
	^ underlineLevel! !

!SmlBasicProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:27'!
bold
	bold _ true! !

!SmlBasicProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 11:49'!
emphasis
	emphasis == #noEmphasis ifTrue: [emphasis _ #emphasis. ^ self].
	emphasis == #emphasis ifTrue: [emphasis _ #noEmphasis. ^ self].
	emphasis == #strongEmphasis ifTrue: [^ self].! !

!SmlBasicProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:27'!
italic
	italic _ true! !

!SmlBasicProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 11:45'!
plain
	bold _ false.
	emphasis _ #noEmphasis.
	italic _ false.
	typewritter _ false.
	underlineLevel _ 0
! !

!SmlBasicProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 11:51'!
strongEmphasis
	emphasis _ #strongEmphasis
! !

!SmlBasicProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:35'!
typewritter
	typewritter _ true! !

!SmlBasicProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:36'!
underline
	underlineLevel _ underlineLevel + 1.
	underlineLevel > 3 ifTrue: [underlineLevel _ 3]! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 11:53'!
isBold
	^ bold! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 04:05'!
isColored
	^ false! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:13'!
isEmphasized
	^ emphasis == #emphasis! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 11:53'!
isItalic
	^ italic! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 12:03'!
isPlain
	^ bold == false and: [emphasis == #noEmphasis and: [italic == false and: [typewritter == false and: [underlineLevel = 0]]]]! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 04:05'!
isSized
	^ false! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:15'!
isStrongEmphasized
	^ emphasis == #strongEmphasis! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 11:55'!
isTypewritter
	^ typewritter! !

!SmlBasicProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:12'!
isUnderlined
	^ underlineLevel > 0! !

!SmlBasicProperty methodsFor: 'printing' stamp: 'fg 7/29/2001 13:15'!
printPropertyOn: aStream
	self isPlain 	ifTrue: [aStream nextPutAll: 'plain '. ^ self].
	self isBold ifTrue: [aStream nextPutAll: 'bold '].
	self isEmphasized ifTrue: [aStream nextPutAll: 'emphasis '].
	self isItalic ifTrue: [aStream nextPutAll: 'italic '].
	self isStrongEmphasized ifTrue: [aStream nextPutAll: 'strong '].
	self isTypewritter ifTrue: [aStream nextPutAll: 'typewritter '].
	self isUnderlined	
		ifTrue: 
			[aStream 
				nextPutAll: 'u='; 
				print: underlineLevel;
				space]! !


!SmlDecoratedProperty methodsFor: 'initialization' stamp: 'fg 7/29/2001 00:57'!
on: aSmlProperty
	property _ aSmlProperty! !

!SmlDecoratedProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:18'!
= aProperty
	^ self class == aProperty class
	and: [self property = aProperty property]! !

!SmlDecoratedProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:20'!
hash
	^ self hash bitXor: property hash
! !

!SmlDecoratedProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:48'!
bold
	property bold! !

!SmlDecoratedProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:49'!
emphasis
	property emphasis! !

!SmlDecoratedProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:49'!
italic
	property italic! !

!SmlDecoratedProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:49'!
plain
	property plain! !

!SmlDecoratedProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:49'!
strongEmphasis
	property strongEmphasis! !

!SmlDecoratedProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:49'!
typewritter
	property typewritter! !

!SmlDecoratedProperty methodsFor: 'modifying attributes' stamp: 'fg 7/29/2001 00:50'!
underline
	property underline! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:08'!
isBold
	^ property isBold! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 04:08'!
isColored
	^ property isColored! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:13'!
isEmphasized
	^ property isEmphasized! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:09'!
isItalic
	^ property isItalic! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:09'!
isPlain
	^ property isPlain! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 04:08'!
isSized
	^ property isSized! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:15'!
isStrongEmphasized
	^ property isStrongEmphasized! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/29/2001 13:09'!
isTypewritter
	^ property isTypewritter! !

!SmlDecoratedProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 04:07'!
isUnderlined
	^ property isUnderlined! !


!SmlColorProperty methodsFor: 'modifying color' stamp: 'fg 7/29/2001 12:53'!
fontColor: aSymbol
	fontColor _ aSymbol! !

!SmlColorProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:22'!
= aProperty
	^ super = aProperty
	and: [fontColor = aProperty fontColor]! !

!SmlColorProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:24'!
hash
	^ super hash bitXor: fontColor! !

!SmlColorProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 04:07'!
isColored
	^ true! !

!SmlColorProperty methodsFor: 'accessing' stamp: 'fg 7/30/2001 07:23'!
fontColor 
	^ fontColor! !

!SmlColorProperty methodsFor: 'printing' stamp: 'fg 7/29/2001 13:01'!
printPropertyOn: aStream
	property printPropertyOn: aStream.
	aStream 
		nextPutAll: 'color=';
		print: fontColor;
		space! !


!SmlProperty class methodsFor: 'instance creation' stamp: 'fg 7/30/2001 08:01'!
plain
	^ SmlBasicProperty new! !


!SmlBasicProperty class methodsFor: 'instance creation' stamp: 'fg 7/28/2001 22:14'!
new
	^ super new initialize! !


!SmlDecoratedProperty class methodsFor: 'instance creation' stamp: 'fg 7/29/2001 00:56'!
on: aSmlProperty
	^ self new on: aSmlProperty! !


!SmlScanner methodsFor: 'initialization' stamp: 'fg 7/28/2001 04:04'!
on: aStringOrStream
	buffer _ WriteStream on: (String new: 1024).
	source _ aStringOrStream readStream.
	self step.
	self step.
! !

!SmlScanner methodsFor: 'accessing' stamp: 'fg 7/28/2001 03:11'!
hereCharType
	^ TypeTable at: hereChar asciiValue! !

!SmlScanner methodsFor: 'accessing' stamp: 'fg 7/28/2001 03:21'!
scannedString
	^source contents printString! !

!SmlScanner methodsFor: 'accessing' stamp: 'fg 7/28/2001 21:02'!
tokens
	| answer |
	answer := OrderedCollection new: source size // 10.
	[self scanToken == #endOfStream]
		whileFalse: [answer add: (Array with: tokenType with: token)].
	^ answer
! !

!SmlScanner methodsFor: 'scanning' stamp: 'fg 7/28/2001 03:06'!
scanToken
	self perform: (TypeTable at: hereChar asciiValue).
	^ token
! !

!SmlScanner methodsFor: 'scanning' stamp: 'fg 7/28/2001 02:24'!
step
	| answer |
	answer _ hereChar.
	hereChar _ aheadChar.
	aheadChar _ source atEnd
					ifTrue: [30 asCharacter "xEndOfStream"]
					ifFalse: [source next].
	^ answer
! !

!SmlScanner methodsFor: 'scanning' stamp: 'fg 7/28/2001 03:43'!
xEndOfStream
	tokenType _ #endOfStream.
	token _ #endOfStream! !

!SmlScanner methodsFor: 'scanning' stamp: 'fg 7/28/2001 03:26'!
xInvalidChar
	self fail: 'Invalid character 0x', hereChar hex, ' encountered'
 
! !

!SmlScanner methodsFor: 'scanning' stamp: 'fg 7/28/2001 04:41'!
xPrintableChar
	buffer reset.
	[self hereCharType == #xPrintableChar]
		whileTrue: [buffer nextPut: self step].
	tokenType _ #word.
	token _ buffer contents
! !

!SmlScanner methodsFor: 'scanning' stamp: 'fg 7/28/2001 05:29'!
xTagBegin
	buffer reset.
	self step. "eat openning angle"
	hereChar = $/
		ifTrue: [tokenType _ #closeTag. self step]
		ifFalse: [tokenType _ #openTag].
	[self hereCharType == #xPrintableChar]
		whileTrue: [buffer nextPut: self step].
	self hereCharType ~= #xTagEnd
		ifTrue: [self fail: 'Expecting closing angle (>)'].
	self step. "eat closing angle"
	token _ buffer contents asSymbol
! !

!SmlScanner methodsFor: 'scanning' stamp: 'fg 7/28/2001 03:42'!
xTagEnd
	self fail: 'Missing openning angle (<)' 
! !

!SmlScanner methodsFor: 'scanning' stamp: 'fg 7/28/2001 04:41'!
xWhitespace
	buffer reset.
	[self hereCharType == #xWhitespace]
		whileTrue: [buffer nextPut: self step].
	tokenType _ #blank.
	token _ buffer contents
! !

!SmlScanner methodsFor: 'error handling' stamp: 'fg 7/28/2001 03:18'!
composeMessage: aString
	^String streamContents: 
		[:stream | 
		stream 
			nextPutAll: aString; 
			nextPutAll: ' in ';
			nextPut: $';
			nextPutAll: self scannedString;
			nextPut: $']
! !

!SmlScanner methodsFor: 'error handling' stamp: 'fg 7/30/2001 13:26'!
fail: aString
	^Error new 
		messageText: (self composeMessage: aString);
		signal
! !


!SmlParser methodsFor: 'initialization' stamp: 'fg 7/29/2001 23:40'!
initialize
	tagStack _ OrderedCollection new.
	resultStack _ OrderedCollection new.
	result _ SmlCompositeText new.
! !

!SmlParser methodsFor: 'initialization' stamp: 'fg 7/28/2001 20:28'!
on: aStringOrStream
	super on: aStringOrStream.
	self advance.
	self advance
! !

!SmlParser methodsFor: 'stack operations' stamp: 'fg 7/29/2001 23:53'!
popTaggedText
	result _ resultStack removeLast addText: tagStack removeLast! !

!SmlParser methodsFor: 'stack operations' stamp: 'fg 7/30/2001 02:30'!
pushTaggedText: aSmlTaggedText
	tagStack add: aSmlTaggedText.
	resultStack add: result.
	result _ aSmlTaggedText text.! !

!SmlParser methodsFor: 'stack operations' stamp: 'fg 7/29/2001 23:07'!
topTag
	^ tagStack isEmpty 
		ifTrue: [nil]
		ifFalse: [tagStack last tag]! !

!SmlParser methodsFor: 'parsing' stamp: 'fg 7/28/2001 12:29'!
advance
	| answer |
	answer _ here.
	here _ token.
	hereType _ tokenType.
	self scanToken.
	^ answer
! !

!SmlParser methodsFor: 'parsing' stamp: 'fg 7/29/2001 22:31'!
closeTag
	self topTag = here 
		ifFalse: [self fail: 'Missing opening tag for ', here].
	self popTaggedText.
	self advance
! !

!SmlParser methodsFor: 'parsing' stamp: 'fg 7/29/2001 22:31'!
openTag
	self pushTaggedText: (SmlTaggedText new tag: self advance)

! !

!SmlParser methodsFor: 'parsing' stamp: 'fg 7/29/2001 23:52'!
plainText
	"
	plainText ::= (<word> | <blank>)* 
	" 
	| plainText lastType |
	plainText _ SmlPlainText new.
	hereType == #blank ifTrue: [plainText startsWithBlanks].
	[hereType == #word or: [hereType == #blank]]
		whileTrue: 
			[lastType _ hereType.
			hereType == #word ifTrue: [plainText addWord: here].
			hereType == #blank 	ifTrue: [plainText addBlank: here].
			self  advance.
			hereType == lastType 
				ifTrue: [self fail: 'Words and Blanks should alternate']].
	lastType == #word ifTrue: [plainText endsWithWord].
	result addText: plainText
		
	! !

!SmlParser methodsFor: 'parsing' stamp: 'fg 7/29/2001 20:45'!
text
	"
	text ::= (<openTag> | <closeTag> | plainText)*
	plainText ::= (<word> | <blank>)* 
	" 
	[hereType == #endOfStream]
		whileFalse: 
			[hereType == #openTag
				ifTrue: [self openTag].
			hereType == #closeTag
				ifTrue: [self closeTag].
			(hereType == #word or: [hereType == #blank])
				ifTrue: [self plainText]].
	 tagStack isEmpty 
		ifFalse: [self fail: 'Missing closing tag for: ', self topTag].
	^ result! !


!SmlScanner class methodsFor: 'instance creation' stamp: 'fg 7/28/2001 04:31'!
on: aStringOrStream
	"
	(SmlScanner on:  '<7><PL><B>ICFP 2001 Programming Contest</B></PL></7>') contents 
	"	

	^ self new on: aStringOrStream
! !

!SmlScanner class methodsFor: 'class initialization' stamp: 'fg 7/28/2001 02:58'!
initialize
	"
	SmlScanner initialize
	"

	| newTable |
	newTable _ Array new: 255 withAll: #xInvalidChar. 
	newTable atAll: #(9 10 13 32 ) put: #xWhitespace. "tab lf cr space"
	newTable atAll: (33 to: 126) put: #xPrintableChar.
	newTable at: $< asciiValue 	put: #xTagBegin.
	newTable at: $> asciiValue   put: #xTagEnd.
	newTable at: 30 put: #xEndOfStream.

	TypeTable _ newTable.
	^TypeTable
! !


!SmlParser class methodsFor: 'instance creation' stamp: 'fg 7/28/2001 12:15'!
new
	^ super new initialize! !

!SmlParser class methodsFor: 'instance creation' stamp: 'fg 7/28/2001 12:14'!
on: aStringOrStream
	^ self new on: aStringOrStream
! !

!SmlParser class methodsFor: 'instance creation' stamp: 'fg 7/31/2001 21:08'!
parse: aStringOrStream
	^ (self on: aStringOrStream) text
! !


!SmlSizeProperty methodsFor: 'modifying size' stamp: 'fg 7/29/2001 00:52'!
pointSize: anInteger
	pointSize _ anInteger! !

!SmlSizeProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:22'!
= aProperty
	^ super = aProperty
	and: [pointSize = aProperty pointSize]! !

!SmlSizeProperty methodsFor: 'comparing' stamp: 'fg 7/30/2001 07:24'!
hash
	^ super hash bitXor: pointSize! !

!SmlSizeProperty methodsFor: 'testing' stamp: 'fg 7/30/2001 04:08'!
isSized
	^ true! !

!SmlSizeProperty methodsFor: 'accessing' stamp: 'fg 7/30/2001 07:23'!
pointSize
	^ pointSize! !

!SmlSizeProperty methodsFor: 'printing' stamp: 'fg 7/29/2001 13:01'!
printPropertyOn: aStream
	property printPropertyOn: aStream.
	aStream 
		nextPutAll: 'size=';
		print: pointSize;
		space! !


!SmlText methodsFor: 'initialization' stamp: 'fg 7/29/2001 14:54'!
initialize
	"do nothing"! !

!SmlText methodsFor: 'enumeration' stamp: 'fg 7/30/2001 05:33'!
decoratedTextDo: aBlock
	self subclassResponsibility ! !

!SmlText methodsFor: 'decorating' stamp: 'fg 7/30/2001 13:11'!
asDecoratedText
	^ self decorated! !

!SmlText methodsFor: 'decorating' stamp: 'fg 7/30/2001 13:19'!
decorateWith: aProperty addingTo: aCollection
	self subclassResponsibility 
! !

!SmlText methodsFor: 'decorating' stamp: 'fg 7/30/2001 13:11'!
decorated
	| collection |
	collection _ OrderedCollection new.
	self decorateWith: SmlProperty plain addingTo: collection.
	^ collection! !


!SmlCompositeText methodsFor: 'initalization' stamp: 'fg 7/29/2001 16:52'!
initialize
	textCollection _ OrderedCollection new! !

!SmlCompositeText methodsFor: 'adding' stamp: 'fg 7/29/2001 16:52'!
addText: aSmlText
	textCollection add: aSmlText! !

!SmlCompositeText methodsFor: 'decorating' stamp: 'fg 7/30/2001 13:15'!
decorateWith: aProperty addingTo: aCollection
	textCollection do: [:text | text decorateWith: aProperty addingTo: aCollection]
! !

!SmlCompositeText methodsFor: 'enumeration' stamp: 'fg 7/30/2001 05:31'!
decoratedTextDo: aBlock
	textCollection do: [:text | text decoratedTextDo: aBlock]! !

!SmlCompositeText methodsFor: 'printing' stamp: 'fg 7/29/2001 23:47'!
printOn: aStream
	textCollection isEmpty ifTrue: [^ self].
	textCollection do: [:text | text printOn: aStream]
! !

!SmlCompositeText methodsFor: 'accessing' stamp: 'fg 8/1/2001 01:29'!
textCollection
	^ textCollection ! !


!SmlDecoratedText methodsFor: 'accessing' stamp: 'fg 7/30/2001 05:36'!
property
	^ property! !

!SmlDecoratedText methodsFor: 'accessing' stamp: 'fg 7/30/2001 00:35'!
property: aSmlProperty
	property _ aSmlProperty! !

!SmlDecoratedText methodsFor: 'accessing' stamp: 'fg 7/30/2001 05:36'!
string
	^ string! !

!SmlDecoratedText methodsFor: 'accessing' stamp: 'fg 7/30/2001 04:23'!
string: aString
	string _ aString ! !

!SmlDecoratedText methodsFor: 'decorating' stamp: 'fg 7/30/2001 00:25'!
decorated
	^ self! !

!SmlDecoratedText methodsFor: 'enumeration' stamp: 'fg 7/30/2001 05:30'!
decoratedTextDo: aBlock
	aBlock value: self! !

!SmlDecoratedText methodsFor: 'printing' stamp: 'fg 7/30/2001 02:03'!
printOn: aStream
	string isEmpty ifTrue: [^ self].
	aStream
		print: property;
		nextPut: $(;
		nextPutAll: string;
		nextPut: $)! !


!SmlPlainText methodsFor: 'initialization' stamp: 'fg 7/28/2001 12:38'!
initialize
	words _ OrderedCollection new.
	blanks _ OrderedCollection new
 ! !

!SmlPlainText methodsFor: 'decorating' stamp: 'fg 7/30/2001 13:18'!
decorateWith: aProperty addingTo: aCollection 
	aCollection add: 
		(SmlDecoratedText new 
			property: aProperty;
			string: (self printStringWithProperty: aProperty))! !

!SmlPlainText methodsFor: 'accessing' stamp: 'fg 7/29/2001 16:21'!
addBlank: aString
	blanks add: aString! !

!SmlPlainText methodsFor: 'accessing' stamp: 'fg 7/29/2001 16:21'!
addWord: aString
	words add: aString! !

!SmlPlainText methodsFor: 'accessing' stamp: 'fg 8/1/2001 01:32'!
blanks
	^ blanks ! !

!SmlPlainText methodsFor: 'accessing' stamp: 'fg 7/29/2001 16:41'!
endsWithWord
	blanks add: ''! !

!SmlPlainText methodsFor: 'accessing' stamp: 'fg 7/30/2001 00:43'!
size
	"estimated size.."

	^ (words inject: 0 into: [:acum :word | acum + word size]) + blanks size ! !

!SmlPlainText methodsFor: 'accessing' stamp: 'fg 7/29/2001 16:25'!
startsWithBlanks
	"If it starts with blanks, then put an empty word"

	words add: ''! !

!SmlPlainText methodsFor: 'accessing' stamp: 'fg 8/1/2001 01:32'!
words
	^ words ! !

!SmlPlainText methodsFor: 'printing' stamp: 'fg 7/30/2001 00:58'!
printOn: aStream
	aStream nextPutAll: self sensitivePrintString
! !

!SmlPlainText methodsFor: 'printing' stamp: 'fg 7/30/2001 04:23'!
printStringWithProperty: aProperty
	^ aProperty isTypewritter	
		ifTrue: [self sensitivePrintString]
		ifFalse: [self unSensitivePrintString]



		

				
! !

!SmlPlainText methodsFor: 'printing' stamp: 'fg 7/30/2001 00:58'!
sensitivePrintString
	^ String streamContents: 
		[:stream |
		words with: blanks do: 
			[:w :b | 
			stream 
				nextPutAll: w; 
				nextPutAll: b]]
! !

!SmlPlainText methodsFor: 'printing' stamp: 'fg 7/30/2001 03:37'!
unSensitivePrintString
	^ String streamContents: 
		[:stream |
		words with: blanks do: 
			[:w :b | 
			stream 
				nextPutAll: w; 
				space].
		blanks last isEmpty ifTrue: [stream skip: -1]]
! !


!SmlTaggedText methodsFor: 'initialization' stamp: 'fg 7/30/2001 02:40'!
initialize
	text _ SmlCompositeText new! !

!SmlTaggedText methodsFor: 'accessing' stamp: 'fg 7/29/2001 22:40'!
tag
	^ tag
! !

!SmlTaggedText methodsFor: 'accessing' stamp: 'fg 7/29/2001 20:35'!
tag: aSymbol 
	tag _ aSymbol
! !

!SmlTaggedText methodsFor: 'accessing' stamp: 'fg 7/30/2001 02:29'!
text
	^ text
! !

!SmlTaggedText methodsFor: 'decorating' stamp: 'fg 7/30/2001 13:20'!
decorateWith: aProperty addingTo: aCollection
	text decorateWith: (self modifiedProperty: aProperty) addingTo: aCollection! !

!SmlTaggedText methodsFor: 'decorating' stamp: 'fg 7/30/2001 01:25'!
modifiedProperty: aProperty
	^ aProperty shallowCopy perform: self tagMeaning! !

!SmlTaggedText methodsFor: 'decorating' stamp: 'fg 7/29/2001 00:13'!
tagMeaning
	^ TagMeanings at: tag ifAbsent: [self error: 'Unrecognized tag name: ', tag]! !

!SmlTaggedText methodsFor: 'printing' stamp: 'fg 7/30/2001 12:35'!
printOn: aStream
	aStream
		nextPut: $<;
		nextPutAll: tag;
		nextPut: $>;
		print: text;
		nextPut: $<;
		nextPut: $/;
		nextPutAll: tag;
		nextPut: $>! !


!SmlText class methodsFor: 'instance creation' stamp: 'fg 7/29/2001 14:48'!
new
	^ super new initialize! !


!SmlPlainText class methodsFor: 'instance creation' stamp: 'fg 7/28/2001 12:37'!
new
	^ super new initialize! !

!SmlPlainText class methodsFor: 'instance creation' stamp: 'fg 7/29/2001 21:23'!
sample
	^ self new
		startsWithBlanks;
		addBlank: '	';
		addWord: 'sample';
		endsWithWord! !

!SmlPlainText class methodsFor: 'instance creation' stamp: 'fg 7/29/2001 21:24'!
sample2
	^ self new
		addWord: 'sample2';
		addBlank: ' '! !


!SmlTaggedText class methodsFor: 'class initialization' stamp: 'fg 7/29/2001 00:43'!
initialize
	"
	SmlTaggedText initialize
	"
	TagMeanings _ Dictionary new
		at: #B 		put: #bold;
		at: #I		put: #italic;
		at: #EM		put: #emphasis;
		at: #PL		put: #plain;
		at: #S		put: #strongEmphasis;
		at: #TT		put: #typewritter;
		at: #U		put: #underline;
		"color"
		at: #r		put: #red;
		at: #g		put: #green;
		at: #b		put: #blue;
		at: #c		put: #cyan;
		at: #m		put: #magenta;
		at: #y		put: #yellow;
		at: #k		put: #black;
		at: #w		put: #white;
		"point size"
		at: #'0'		put: #size0;
		at: #'1'		put: #size1;
		at: #'2'		put: #size2;
		at: #'3'		put: #size3;
		at: #'4'		put: #size4;
		at: #'5'		put: #size5;
		at: #'6'		put: #size6;
		at: #'7'		put: #size7;
		at: #'8'		put: #size8;
		at: #'9'		put: #size9;
		yourself! !


!SmlTextRun methodsFor: 'initialization' stamp: 'fg 7/30/2001 08:25'!
initialize
	plainString _ String new.
	strings _ OrderedCollection new.
	propertyRun _ SmlPropertyRun new! !

!SmlTextRun methodsFor: 'adding' stamp: 'fg 7/30/2001 07:46'!
addString: aString withProperty: aProperty
	(strings isEmpty and: [aProperty isPlain])
		ifTrue: 
			[plainString _ plainString , aString. 
			^ self].

	properties isEmpty 
		ifTrue:
			[properties add: aProperty.
			strings add: aString.
			^ self].

	properties last = aProperty 
		ifTrue: [^ strings add: (strings removeLast withoutTrailingBlanks , aString)].

	properties add: aProperty.
	strings add: aString.! !


!WriteStream methodsFor: 'accessing' stamp: 'fg 7/30/2001 00:46'!
writeStream
	^ self! !

SmlTaggedText initialize!

!SmlTaggedText class reorganize!
('class initialization' initialize)
!


!SmlCompositeText class reorganize!
('as yet unclassified')
!


!SmlTaggedText reorganize!
('initialization' initialize)
('accessing' tag tag: text)
('decorating' decorateWith:addingTo: modifiedProperty: tagMeaning)
('printing' printOn:)
!


!SmlPlainText reorganize!
('initialization' initialize)
('decorating' decorateWith:addingTo:)
('accessing' addBlank: addWord: blanks endsWithWord size startsWithBlanks words)
('printing' printOn: printStringWithProperty: sensitivePrintString unSensitivePrintString)
!


!SmlDecoratedText reorganize!
('accessing' property property: string string:)
('decorating' decorated)
('enumeration' decoratedTextDo:)
('printing' printOn:)
!


!SmlCompositeText reorganize!
('initalization' initialize)
('adding' addText:)
('decorating' decorateWith:addingTo:)
('enumeration' decoratedTextDo:)
('printing' printOn:)
('accessing' textCollection)
!


!SmlText reorganize!
('initialization' initialize)
('enumeration' decoratedTextDo:)
('decorating' asDecoratedText decorateWith:addingTo: decorated)
!

SmlScanner initialize!

!SmlParser reorganize!
('initialization' initialize on:)
('stack operations' popTaggedText pushTaggedText: topTag)
('parsing' advance closeTag openTag plainText text)
!


!SmlScanner reorganize!
('initialization' on:)
('accessing' hereCharType scannedString tokens)
('scanning' scanToken step xEndOfStream xInvalidChar xPrintableChar xTagBegin xTagEnd xWhitespace)
('error handling' composeMessage: fail:)
!


!SmlBasicProperty class reorganize!
('instance creation' new)
!


!SmlDecoratedProperty reorganize!
('initialization' on:)
('comparing' = hash)
('modifying attributes' bold emphasis italic plain strongEmphasis typewritter underline)
('testing' isBold isColored isEmphasized isItalic isPlain isSized isStrongEmphasized isTypewritter isUnderlined)
!


!SmlBasicProperty reorganize!
('comparing' = hash)
('initialization' initialize)
('accessing' emphasisSymbol underlineLevel)
('modifying attributes' bold emphasis italic plain strongEmphasis typewritter underline)
('testing' isBold isColored isEmphasized isItalic isPlain isSized isStrongEmphasized isTypewritter isUnderlined)
('printing' printPropertyOn:)
!


!SmlProperty reorganize!
('comparing' = hash)
('modifying attributes' bold emphasis italic plain strongEmphasis typewritter underline)
('modifying size' pointSize: size0 size1 size2 size3 size4 size5 size6 size7 size8 size9)
('modifying color' black blue cyan fontColor: green magenta red white yellow)
('testing' affectsBlanks isBold isColored isEmphasized isItalic isPlain isSized isStrongEmphasized isTypewritter isUnderlined)
('printing' printOn: printPropertyOn:)
!

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

SmlScanner initialize.!

