'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 1 August 2001 at 1:47:11 am'!
"Change Set:		Sml-Testing
Date:			31 July 2001
Author:			Francisco Garau

TestSmlParsing runSuite

"!

TestCase subclass: #TestSmlParsing
	instanceVariableNames: 'string '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sml-Test'!

!TestSmlParsing methodsFor: 'accessing' stamp: 'fg 7/31/2001 21:08'!
decoratedText
	^ (SmlParser parse: string) decorated
! !

!TestSmlParsing methodsFor: 'accessing' stamp: 'fg 7/31/2001 14:54'!
parsedText
	^ SmlParser parse: string
! !

!TestSmlParsing methodsFor: 'accessing' stamp: 'fg 7/31/2001 14:02'!
string: aString
	string := aString
! !

!TestSmlParsing methodsFor: 'printing' stamp: 'fg 7/31/2001 14:03'!
printOn: aStream
	string isNil ifTrue: [^super printOn: aStream].
	aStream 
		print: string;
		nextPutAll: ' should be ';
		print: testMessage
! !

!TestSmlParsing methodsFor: 'running' stamp: 'fg 7/31/2001 14:03'!
debug
	(self class selector: testMessage) string: string; runCase

! !

!TestSmlParsing methodsFor: 'testing' stamp: 'fg 7/31/2001 14:34'!
invalid
	self value: [self expression] shouldRaise: Error
! !

!TestSmlParsing methodsFor: 'testing' stamp: 'fg 8/1/2001 01:37'!
plainText
	| text |
	text _ self parsedText.
	self assert: text class == SmlCompositeText.
	text _ text textCollection first.
	self assert: text class == SmlPlainText.
	self assert: text unSensitivePrintString = 'hello world'! !

!TestSmlParsing methodsFor: 'testing' stamp: 'fg 7/31/2001 21:09'!
singleStringBolded
	| text |
	text _ self decoratedText first.
	self assert: text class == SmlDecoratedText.
	self assert: text string = ' hello world '.
	self assert: text property isBold.
	self assert: text property isUnderlined not.
	self assert: text property = SmlProperty plain bold 
! !


!TestSmlParsing class methodsFor: 'building tests' stamp: 'fg 7/31/2001 14:04'!
assert: aSymbol onEach: aCollection
	^aCollection collect: [:each | (self selector: aSymbol) string: each]
! !

!TestSmlParsing class methodsFor: 'building tests' stamp: 'fg 7/31/2001 14:45'!
invalidTags
	^self assert: #invalid onEach: #(
	'<U>'
	'</U>'
	'< B></B>'
	'< B></B>'
	'<B>< /B>'
	'<B></ B>'
	'<B></B >'
	'<z></z>'
	'<x> </x>'
	'<yy> </yy>'
	'<B><U></B></U>'
	)
! !

!TestSmlParsing class methodsFor: 'building tests' stamp: 'fg 8/1/2001 01:42'!
plainText
	^ self assert: #plainText onEach: #(
	'hello world'
	'hello   world'
	'hello 	
	world'
	)
! !

!TestSmlParsing class methodsFor: 'building tests' stamp: 'fg 8/1/2001 01:45'!
runSuite
	TestModel runSuite: self suite
! !

!TestSmlParsing class methodsFor: 'building tests' stamp: 'fg 7/31/2001 15:08'!
singleStringBolded
	^self assert: #singleStringBolded onEach: #(
	'<B> hello world </B>'
	'<B>      hello world   </B>'
	'<B>		hello	  world		  </B>'
	'<B>		
	hello	world	
	</B>'
	'<B>     hello world 		  </B>'
	)
! !

!TestSmlParsing class methodsFor: 'building tests' stamp: 'fg 7/31/2001 21:04'!
suite
	"
	TestModel runSuite: TestSmlParsing suite
	"
	^TestSuite new
		addTests: self invalidTags;
		addTests: self singleStringBolded;
		addTests: self plainText;
		yourself
! !

